unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Spin,
  StdCtrls;

type
  { TMyButton }
  TMyButton=class(TButton)
    FBitmap:TBitmap;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure ShapeThisButton(W,H:integer);
    procedure Resize; override;
  end;

  { TForm1 }
  TForm1 = class(TForm)
    SpinEdit1: TSpinEdit;
    button:TMyButton;
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit1EditingDone(Sender: TObject);
    //procedure ShapeThisForm;
    //procedure buttonclick(sender:TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;



var
  Form1: TForm1;

implementation

{ TForm1 }

procedure TForm1.SpinEdit1EditingDone(Sender: TObject);
var i:integer;
begin
  i:=SpinEdit1.Value;
  button.SetBounds(10,10,4*i,round(1.5*i));
end;

//procedure TForm1.ShapeThisForm;
//var ABitmap:TBitmap;
//begin
//  ABitmap:=TBitmap.Create;
//  ABitmap.Monochrome:=true;
//  ABitmap.SetSize(Width,Height);
//  ABitmap.Canvas.Brush.Color:=clBlack;
//  ABitmap.Canvas.Rectangle(0,0,Width,Height);
//  ABitmap.Canvas.Brush.Color:=clWhite;
//  ABitmap.Canvas.Ellipse(0,0,Width,Height);
//  SetShape(ABitmap);
//  FreeAndNil(ABitmap);
//end;
//
//procedure TForm1.buttonclick(sender: TObject);
//begin
//  ShapeThisForm;
//end;
//

procedure TForm1.FormCreate(Sender: TObject);
begin
  button:=TMyButton.Create(self);
  button.Parent:=self;
  button.Caption:='Do not press Button';
  //button.OnClick:=@buttonclick;
end;

{$R *.lfm}

{ TMyButton }

constructor TMyButton.Create(TheOwner: TComponent);
begin
  FBitmap:=TBitmap.Create;
  FBitmap.Monochrome:=true;
  inherited Create(TheOwner);
end;

destructor TMyButton.Destroy;
begin
  FreeAndNil(FBitmap);
  inherited Destroy;
end;

procedure TMyButton.ShapeThisButton(W,H:integer);
begin
  FBitmap.SetSize(W,H);
  FBitmap.Canvas.Brush.Color:=clBlack;
  FBitmap.Canvas.Rectangle(0,0,W,H);
  FBitmap.Canvas.Brush.Color:=clWhite;
  FBitmap.Canvas.Ellipse(0,0,W,H);
  SetShape(FBitmap);
end;

procedure TMyButton.Resize;
begin
  inherited Resize;
  ShapeThisButton(Width, Height);
end;


end.

